package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.UserGroupDetail;
import com.sa.ibiz.demo.demo.service.UserGroupDetailService;
import com.sa.ibiz.demo.demo.service.dto.UserGroupDetailSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/usergroupdetail")
public class UserGroupDetailResource
{
	@Autowired
	private UserGroupDetailService service;


	@PostMapping(value = "/create")
	public ResponseEntity<UserGroupDetail> create(@Validated @RequestBody UserGroupDetail data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("用户组成员[create]操作发生错误","UserGroupDetail",data.getUsergroupdetailid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/update")
	public ResponseEntity<UserGroupDetail> update(@Validated @RequestBody UserGroupDetail data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("用户组成员[update]操作发生错误","UserGroupDetail",data.getUsergroupdetailid().toString());
		return ResponseEntity.ok().body(data);
	}
	@GetMapping(value = "/{id}")
	public ResponseEntity<UserGroupDetail> get(@Validated @PathVariable String id){
		UserGroupDetail data=new UserGroupDetail();
		data.setUsergroupdetailid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("用户组成员[get]操作发生错误","UserGroupDetail",id.toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/checkKey")
	public ResponseEntity<UserGroupDetail> checkKey(@Validated @RequestBody UserGroupDetail data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("用户组成员[checkKey]操作发生错误","UserGroupDetail",data.getUsergroupdetailid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<UserGroupDetail> getDraft(@Validated @RequestBody UserGroupDetail data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("用户组成员[getDraft]操作发生错误","UserGroupDetail","");
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/remove")
	public ResponseEntity<UserGroupDetail> remove(@Validated @RequestBody UserGroupDetail data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("用户组成员[remove]操作发生错误","UserGroupDetail",data.getUsergroupdetailid().toString());
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<UserGroupDetail>> searchDefaultPage(@Validated @RequestBody UserGroupDetailSearchFilter filter){
		Page<UserGroupDetail> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<UserGroupDetail>> listDefault(@Validated @RequestBody UserGroupDetailSearchFilter filter){
		List<UserGroupDetail> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
